#!/usr/bin/perl
require "bbconfig";

$READ_DB= $USERPATH . "read";
 					#Find the first notice file.
$ABSOLUTE_DB_PATH = $DBPATH . $DBFILE;

unless (-e $USERPATH) {
	unless (! system("mkdir $USERPATH")){
		PrintError("Couldn't create $USERPATH. <p>");
	}
}

unless (-e $READ_DB) {			#first time user w/ no file?

	unless (! system("touch $READ_DB")){
		PrintError("Couldn't create $READ_DB. <p>");
	}

}					#complain if unsuccessful

open (DB_HANDLE, $ABSOLUTE_DB_PATH) ||
	PrintError("Couldn't open $ABSOLUTE_DB_PATH!!<p>");

@perm = <DB_HANDLE>;
close (DB_HANDLE);

open (USERFILE, $READ_DB) ||
	PrintError("Couldn't open $ABSOLUTE_DB_PATH. <p>");

@temp=<USERFILE>;
close (USERFILE);

local(%check);
grep($check{$_}++,@temp); 
@unread = grep(!$check{$_},@perm);

$CONSIDER = $unread[0];

if ($CONSIDER) {
	&found_unread;
}
else {
	&no_unread;
}

#-------------------------------------------------------------------
sub found_unread {

	open (USER_HANDLE, ">>". $READ_DB) ||
		PrintError("Couldn't open $ABSOLUTE_DB_PATH. <p>");

	chomp($CONSIDER);
	print USER_HANDLE $CONSIDER, "\n";
	close (USER_HANDLE);

	$POST= $POSTPATH . $CONSIDER;

	&output_article;

	exit 0; 
}

#---------------------------------------------------------------
sub output_article {

	open (FILE_HANDLE, $POST) || PrintError("Couldn't open $POST. <p>");

	$POSTER = <FILE_HANDLE>;
	chop $POSTER;

	#--skipnames check--#
	$skipnames = $USERPATH . "bbskipnames";

	if ( -e $skipnames) {

	        if (system ("grep -q $POSTER $skipnames") == 0) {
	                print "Content-type: text/html\n\n";
	                print "<HTML><HEAD>";
	                print '<meta HTTP-EQUIV="Refresh" ';
	                print "content=\"0;URL=$RELCGI/$cat/unread.cgi\">";
	                print '</HEAD><BODY bgcolor="#000000"></BODY></HTML>';
	                exit 0;
	        };
	}
	#--end skipnames check--#	


	$threadline=<FILE_HANDLE>;
	@tinfo=split /:/,$threadline;  

	$ARTICLE_NUM = $tinfo[0];
	$replies= (@tinfo-1);	#yeah, that's right. :)
	chomp($ARTICLE_NUM);

	$SUBJECT = <FILE_HANDLE>;
	chomp($SUBJECT);

	@TEXT = <FILE_HANDLE>;
	close (FILE_HANDLE);

	&GetAddress;    #find the user's address

	$MAILTO = $names{$POSTER};

	&PrintArticle; 		#located in bbconfig

	&PrintBase;		#located below
}

#-----------------------------------------------------------
sub no_unread {

	print "Content-type: text/html\n\n";
	print "<HTML> <HEAD>\n";
	print "<meta HTTP-EQUIV=Refresh Content=\"1; URL=$RELCGI/markallread.pl/$cat/\">"; 
	print "\n<TITLE>BB $cat</TITLE> </HEAD>"; 
	print "\n<BODY bgcolor=000000 text=FFFFFF link=FFFFFF vlink=FFFFFF>
		\n";
	print "<TABLE BORDER=1 width=80%> <TR>\n";

	print "<TD align=center><b>Num</b></TD> <TD
		align=center><b>Username</b></TD>\n";
	print "<TD align=center><b>Category</b></TD> <TD
		align=center><b>Posted</b></TD>\n";
	print "<TD align=center><b>Expires</b></TD> <TD
		align=center><b>Page</b></TD>\n";
	print "</TR><TR><TD colspan=1> </TD> \n";
	print "<TD colspan=1>&nbsp;</TD> <TD align=center> $CAT</TD>
		\n";
	print "<TD align=center> / / </TD> <TD align=center>
		Never(Yet)</TD> \n";
	print "<TD align=center> &nbsp;</TD> </TR>";

	print "<TR> <TD colspan=6> No Unread Notices Found </TD> </TR>";
	print "</TABLE> <P><P>\n";

	print "</BODY> </HTML>";

	exit 0;
}

#-----------

sub PrintBase {

	print "<center> <a href=$RELCGI/unread.cgi/$cat/>[N]ext</a>\n";
	print "<form action=$RELCGI/getreply.pl/$cat/ method=POST>\n";
	print "<input type=\"submit\" value=\"[R]eply\">\n";
	print "<input type=\"hidden\" name=\"number\" value=\"$ARTICLE_NUM\">\n";
	print "<input type=\"hidden\" name=\"subject\" value=\"$SUBJECT\">\n";
	print "<input type=\"hidden\" name=\"article\" value=\"$POST\">\n";
	print "<p><a href=$RELCGI/htmls.pl/$cat/read/>Exit</a>\n";
	print "</FORM><FORM action=$RELCGI/search.pl/$cat/ method=POST>\n";
	$PREVIOUS = ($ARTICLE_NUM - 1);
	print "<input type=hidden name=artnum value=$PREVIOUS>";
	print "<input type=submit value=[P]revious></FORM>\n"; 

	$user = $ENV{'REMOTE_USER'};
	chomp($user);	

	if ($user eq $POSTER || $user eq $ADMINUSER) {
		&IncludeDeleteButton;
	}

	print "</BODY> </HTML>";


}
#end sub PrintBase

